%global ver_suffix -alpha-1

Name:           maven-plugin-testing
Version:        2.0
Release:        4.alpha1%{?dist}
Summary:        Maven Plugin Testing

Group:          Development/Libraries
License:        ASL 2.0
URL:            http://maven.apache.org/plugin-testing/

#svn export http://svn.apache.org/repos/asf/maven/plugin-testing/tags/maven-plugin-testing-2.0-alpha-1
#tar caf maven-plugin-testing-2.0-alpha-1.tar.xz maven-plugin-testing-2.0-alpha-1
Source0:        %{name}-%{version}%{ver_suffix}.tar.xz

Patch0:         %{name}-maven3-missing-methods.patch

BuildArch: noarch

BuildRequires: junit
BuildRequires: java-devel
BuildRequires: maven
BuildRequires: maven-install-plugin
BuildRequires: maven-compiler-plugin
BuildRequires: maven-resources-plugin
BuildRequires: maven-jar-plugin
BuildRequires: maven-source-plugin
BuildRequires: maven-site-plugin
BuildRequires: plexus-containers-component-metadata
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-doxia-sitetools
BuildRequires: maven-surefire-plugin
BuildRequires: maven-surefire-provider-junit
BuildRequires: maven-shared-reporting-impl
BuildRequires: maven-test-tools

Requires: maven
Requires: jpackage-utils
Requires: java

%description
The Maven Plugin Testing contains the necessary modules
to be able to test Maven Plugins.

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
API documentation for %{name}.

%package harness
Summary: Maven Plugin Testing Mechanism
Group: Development/Libraries
Requires: maven-plugin-testing = %{version}-%{release}
Obsoletes: maven-shared-plugin-testing-harness <= 0:1.2
Provides: maven-shared-plugin-testing-harness = 1:%{version}-%{release}

%description harness
The Maven Plugin Testing Harness provides mechanisms to manage tests on Mojo.

%package tools
Summary: Maven Plugin Testing Tools
Group: Development/Libraries
Requires: maven-plugin-testing = %{version}-%{release}
Obsoletes: maven-shared-plugin-testing-tools <= 0:%{version}-%{release}
Provides: maven-shared-plugin-testing-tools = 1:%{version}-%{release}

%description tools
A set of useful tools to help the Maven Plugin testing.

%package -n maven-test-tools
Summary: Maven Testing Tool
Group: Development/Libraries
Requires: maven-plugin-testing = %{version}-%{release}
Obsoletes: maven-shared-test-tools <= 0:%{version}-%{release}
Provides: maven-shared-test-tools = 1:%{version}-%{release}

%description -n maven-test-tools
Framework to test Maven Plugins with Easymock objects.

%prep
%setup -q -n %{name}-%{version}%{ver_suffix}

%patch0 -p1

%build
mvn-rpmbuild -Dmaven.test.failure.ignore=true install javadoc:aggregate
#tests are skipped due to some test failures most probably caused by issues with our plexus container

%install
# jars
install -d -m 0755 %{buildroot}%{_javadir}/%{name}
install -m 644 maven-plugin-testing-harness/target/%{name}-harness-%{version}%{ver_suffix}.jar  \
                   %{buildroot}%{_javadir}/%{name}/%{name}-harness.jar
install -m 644 maven-plugin-testing-tools/target/%{name}-tools-%{version}%{ver_suffix}.jar \
                 %{buildroot}%{_javadir}/%{name}/%{name}-tools.jar
install -m 644 maven-test-tools/target/maven-test-tools-%{version}%{ver_suffix}.jar  \
       %{buildroot}%{_javadir}/%{name}/maven-test-tools.jar

# poms
install -d -m 755 %{buildroot}%{_mavenpomdir}
install -pm 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}.pom
install -pm 644 maven-plugin-testing-harness/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-harness.pom
install -pm 644 maven-plugin-testing-tools/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-tools.pom
install -pm 644 maven-test-tools/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-maven-test-tools.pom

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}/

%add_maven_depmap -a "org.apache.maven.shared:%{name}" JPP.%{name}-%{name}.pom
%add_maven_depmap -f harness -a "org.apache.maven.shared:%{name}-harness" JPP.%{name}-%{name}-harness.pom %{name}/%{name}-harness.jar
%add_maven_depmap -f tools -a "org.apache.maven.shared:%{name}-tools" JPP.%{name}-%{name}-tools.pom %{name}/%{name}-tools.jar
%add_maven_depmap -f maven-test-tools -a "org.apache.maven.shared:maven-test-tools" JPP.%{name}-maven-test-tools.pom %{name}/maven-test-tools.jar

%pre javadoc
# workaround for rpm bug, can be removed in F-17
[ $1 -gt 1 ] && [ -L %{_javadocdir}/%{name} ] && \
rm -rf $(readlink -f %{_javadocdir}/%{name}) %{_javadocdir}/%{name} || :

%files
%{_mavenpomdir}/JPP.%{name}-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%{_javadocdir}/*

%files harness
%{_javadir}/%{name}/%{name}-harness.jar
%{_mavenpomdir}/JPP.%{name}-%{name}-harness.pom
%{_mavendepmapfragdir}/%{name}-harness

%files tools
%{_javadir}/%{name}/%{name}-tools.jar
%{_mavenpomdir}/JPP.%{name}-%{name}-tools.pom
%{_mavendepmapfragdir}/%{name}-tools

%files -n maven-test-tools
%{_javadir}/%{name}/maven-test-tools.jar
%{_mavenpomdir}/JPP.%{name}-maven-test-tools.pom
%{_mavendepmapfragdir}/%{name}-maven-test-tools

%changelog
* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0-4.alpha1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0-3.alpha1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Thu Nov 10 2011 Jaromir Capik <jcapik@redhat.com> 2.0-2.alpha1
- Structuring mess cleanup (depmap fragments split, removing jar duplicities)

* Wed Nov 09 2011 Jaromir Capik <jcapik@redhat.com> 2.0-1.alpha1
- Update to 2.0-alpha1
- Spec file changes according to the latest guidelines

* Thu Feb 10 2011 Alexander Kurtakov <akurtako@redhat.com> 1.2-9
- Fix building.
- Adapt to current guidelines.

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Sep 20 2010 Yong Yang <yyang@redhat.com> 1.1-7
- Build with plexus-containers 1.5.4

* Mon May 31 2010 Alexander Kurtakov <akurtako@redhat.com> 1.2-6
- Proper obsolete for maven-shared-test-tools.

* Mon May 31 2010 Alexander Kurtakov <akurtako@redhat.com> 1.2-5
- One more item to the depmap.

* Mon May 31 2010 Alexander Kurtakov <akurtako@redhat.com> 1.2-4
- Add depmap to fix build.

* Sat May 29 2010 Alexander Kurtakov <akurtako@redhat.com> 1.2-3
- Obsolete maven-shared-test-tools.

* Thu May 27 2010 Yong Yang <yyang@redhat.com> 1:1.2-2.8
- Fix parent pom install

* Thu May 27 2010 Yong Yang <yyang@redhat.com> 1:1.2-2.7
- Fix installed pom.xml source path

* Thu May 27 2010 Yong Yang <yyang@redhat.com> 1:1.2-2.6
- Add more maven depmap for maven-test-tools and maven-plugin-testing-tools for backward compatibility 

* Thu May 27 2010 Yong Yang <yyang@redhat.com> 1:1.2-2.5
- Fix maven-plugin-testing-tools pom name

* Thu May 27 2010 Yong Yang <yyang@redhat.com> 1:1.2-2.4
- Change JPP.%{name}.%{name}-harness.pom to JPP.%{name}-%{name}-harness.pom

* Thu May 27 2010 Yong Yang <yyang@redhat.com> 1:1.2-2.3
- Remove epoch in Requires of maven-test-tools

* Wed May 12 2010 Alexander Kurtakov <akurtako@redhat.com> 1:1.2-2
- Fix line lengths and use macroses consistently.
- Add comment for the tests skip.
- Add missing requires and set permissions.

* Wed May 12 2010 Alexander Kurtakov <akurtako@redhat.com> 1:1.2-1
- Initial package.
